SIGPROCMASK(2)

NAME
sigprocmask - manipulate current signal mask

SYNOPSIS
#include <signal.h>
int
sigprocmask(int how, const sigset_t *set, sigset_t *oset);

DESCRIPTION
The sigprocmask() function examines and/or changes the current signal mask (those signals that are blocked from delivery). Signals are blocked if they are members of the current signal mask set.

If set is not null, the action of sigprocmask() depends on the value of the parameter how, which can be one of the following values:

SIG_BLOCK
    The new mask is the union of the current mask and the specified set.

SIG_UNBLOCK
    The new mask is the intersection of the current mask and the complement of the specified set.

SIG_SETMASK
    The current mask is replaced by the specified set.

If oset is not null, it is set to the previous value of the signal mask. When set is null, the value of how is insignificant and the mask remains unchanged, providing a way to examine the signal mask without modification.

The system quietly disallows SIGKILL or SIGSTOP to be blocked.

Only signals which are in the pending state will be blocked. Signals that are explicitly ignored or for which no handler has been installed and where the default action is to discard the signal are not held as pending and will be discarded regardless of the signal mask.

Blocked signals remain in the pending state until another call to sigprocmask() removes the pending signal(s) from the mask. If there are unblocked signals that are pending after the signal mask is updated, at least one will be delivered before sigprocmask() returns.

RETURN VALUES

ERRORS
The sigprocmask() call will fail and the signal mask will be unchanged if one of the following occurs:

[EINVAL]
    how has a value other than those listed here.

SEE ALSO
kill(2), sigaction(2), sigpending(2), sigsuspend(2), sigaddset(3)

STANDARDS
The sigprocmask() function conforms to p1003.1-2008.